
package JK::iPhone;

use strict;
use File::Temp;
use JK::Misc;

my @EXPORT = qw/get_config sb_popup/;

sub get_config {
    my $plist = shift || slowerr( "get_config: specify plist" );

    debug( "* reading PreferenceLoader config" );
    my %ncfg;
    open( PLIST, "plutil -l $plist 2>&1 |" ) || slowerr( "cannot fork plutil: $!" );
    while(<PLIST>){
        if( /^\s*"?([^"]+)"?\s+=\s+"?([^"]+)"?;/ ){
            my ($key,$value) = ($1,$2);
            if( $key eq 'minutes_alert' || $key eq 'data_alert' ){
                my $plan = $key;
                $plan =~ s/_alert$//;
                for my $alert (split /\s+/, $value){
                    my($type,$thresholds) = split(/:/, $alert);
                    for my $threshold (split /,/, $thresholds){
                        push @{$ncfg{$key}{$type}}, $threshold;
                        debug( "* push \@{ncfg{$key}{$type}}, $threshold" );
                    }
                }
            }else{
                $ncfg{$key} = $value;
                debug( "* ncfg{$key} = $value" );
            }
        }
    }
    close PLIST;
    return( \%ncfg );
}

sub sb_popup {
    my $title = shift;
    my $msg = shift;
    my $button = shift;

    # this is too lame XXX QQQ
    my $fh = File::Temp->new();
    my $fname = $fh->filename;
    print $fh <<__EOF__
#!/usr/bin/cycript -p SpringBoard

var message = [[UIAlertView alloc] init];
message.title = "$title";
message.message = "$msg";
[message addButtonWithTitle:\@"$button"];

[message show];
__EOF__
    ;

    close $fh;
    chmod(0744, $fname);
    system( $fname );
}

sub import {
    my $pkg = shift;
    my $caller = caller;

    for my $f ( @EXPORT ){
        no strict;
        *{$caller . '::' . $f} = $pkg->can($f);
    }
}

1;
